%global namedversion %{version}%{?namedreltag}

%global javadoc_version 2.9.1
%global surefire_version 2.15

Name:           jackson-databind
Version:        2.3.0
Release:        2%{?reltag}%{?dist}
Epoch:          0
Summary:        jackson-databind
License:        ASL 2.0
Group:          Development/Java
URL:            http://wiki.fasterxml.com/JacksonHome
%if 0
/bin/rm -rf jackson-databind-2.3.0.tar.xz jackson-databind-2.3.0/ jackson-databind/ .gitignore
/usr/bin/git clone -q -n https://github.com/FasterXML/jackson-databind.git
cd jackson-databind/
/usr/bin/git archive --prefix=jackson-databind-2.3.0/ jackson-databind-2.3.0 | /usr/bin/xz -9 > ../jackson-databind-2.3.0.tar.xz
cd ../
/usr/bin/rhpkg new-sources jackson-databind-2.3.0.tar.xz
/usr/bin/rhpkg prep
%endif
Source0:        jackson-databind-2.3.0.tar.xz
Patch0:         0000-jackson-databind-pom.patch
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
BuildRequires:  jpackage-utils
Requires:       fasterxml-oss-parent >= 0:11
BuildRequires:  fasterxml-oss-parent >= 0:11
Requires:       jackson-annotations >= 0:2.3.0
BuildRequires:  jackson-annotations >= 0:2.3.0
Requires:       jackson-core >= 0:2.3.0
BuildRequires:  jackson-core >= 0:2.3.0
BuildRequires:  junit >= 0:4.10
BuildRequires:  cglib >= 0:2.2.2
BuildRequires:  groovy17 >= 0:1.7.9
BuildRequires:  maven-surefire-plugin >= 0:%{surefire_version}
BuildRequires:  maven-javadoc-plugin >= 0:%{javadoc_version}
BuildRequires:  maven-replacer-plugin
#
BuildRequires:  maven-bundle-plugin >= 0:2.3.7
BuildRequires:  build-helper-maven-plugin >= 0:1.7
BuildRequires:  maven-scm-plugin >= 0:1.7
BuildRequires:  doclava >= 0:1.0.3
BuildRequires:  jsilver >= 0:1.0.0
BuildRequires:  maven-jxr-plugin >= 0:2.3
# 2.0-beta-2
BuildRequires:  jdepend-maven-plugin >= 0:2.0
BuildRequires:  maven-surefire-report-plugin >= 0:2.15
BuildRequires:  maven-pmd-plugin >= 0:2.7.1
BuildRequires:  taglist-maven-plugin >= 0:2.4
BuildRequires:  maven-fluido-skin >= 0:1.1
#
BuildRequires:  maven-antrun-plugin >= 0:1.3
# XXX: 2.2-beta-2
BuildRequires:  maven-assembly-plugin >= 0:2.2
BuildRequires:  maven-clean-plugin >= 0:2.5
BuildRequires:  maven-dependency-plugin >= 0:2.0
BuildRequires:  maven-ear-plugin >= 0:2.3.1
BuildRequires:  maven-ejb-plugin >= 0:2.1
BuildRequires:  maven-plugin-plugin >= 0:2.4.3
BuildRequires:  maven-rar-plugin >= 0:2.2
BuildRequires:  maven-release-plugin >= 0:2.4.1
# XXX: 2.1-alpha-2
BuildRequires:  maven-war-plugin >= 0:2.1
BuildRequires:  cobertura-maven-plugin >= 0:2.5.1
#
BuildRequires:  maven-compiler-plugin
BuildRequires:  maven-default-skin
BuildRequires:  maven-deploy-plugin
BuildRequires:  maven-enforcer-plugin
BuildRequires:  maven-install-plugin
BuildRequires:  maven-jar-plugin
BuildRequires:  maven-javadoc-plugin
BuildRequires:  maven-project-info-reports-plugin
BuildRequires:  maven-remote-resources-plugin
BuildRequires:  maven-resources-plugin
BuildRequires:  maven-site-plugin
BuildRequires:  maven-source-plugin
BuildRequires:  maven-surefire-plugin
BuildRequires:  surefire-junit4
BuildArch:      noarch
BuildRoot:      %{_tmppath}/jackson-databind-%{namedversion}-%{release}-root

%description
General data-binding functionality for Jackson: works on core streaming API.

%package -n jackson-databind-javadoc
Summary:        Javadoc for jackson-databind
Group:          Development/Documentation
Requires:       jpackage-utils
BuildRequires:  jpackage-utils

%description -n jackson-databind-javadoc
%{summary}.

%package -n jackson-databind-site
Summary:        Site for jackson-databind
Group:          Development/Documentation
Requires:       jpackage-utils
BuildRequires:  jpackage-utils
Requires:       jackson-databind-javadoc = %{epoch}:%{version}-%{release}

%description -n jackson-databind-site
%{summary}.

%prep
%setup -q -n jackson-databind-%{version}
%patch0 -p1 -b .0000~

# XXX: wants repackaged cglib
%{__rm} src/test/java/com/fasterxml/jackson/databind/interop/TestHibernate.java
%{__rm} src/test/java/com/fasterxml/jackson/databind/interop/TestCglibUsage.java

# XXX: no network
%{__rm} src/test/java/com/fasterxml/jackson/databind/deser/TestJdkTypes.java
%{__rm} src/test/java/com/fasterxml/jackson/databind/ser/TestJdkTypes.java

# XXX: not sure
%{__rm} src/test/java/com/fasterxml/jackson/databind/interop/TestGroovyBeans.java

%build
export MAVEN_REPO_LOCAL=${PWD}/.m2/repository
export ALT_DEPLOYMENT_REPOSITORY=remote-repository::default::file://${PWD}/maven2-brew
export MAVEN_OPTS=
%{_bindir}/mvn-jpp -B -e -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DaltDeploymentRepository=${ALT_DEPLOYMENT_REPOSITORY} -DperformRelease -Dsurefire.version=%{surefire_version} -Djavadoc.version=%{javadoc_version} -Denforcer.skip deploy javadoc:aggregate site

%install
%{__rm} -rf %{buildroot}

# jars
%{__mkdir_p} %{buildroot}%{_javadir}
%{__cp} -p maven2-brew/com/fasterxml/jackson/core/jackson-databind/%{namedversion}/jackson-databind-%{namedversion}.jar %{buildroot}%{_javadir}/jackson-databind-%{namedversion}.jar
%{__cp} -p maven2-brew/com/fasterxml/jackson/core/jackson-databind/%{namedversion}/jackson-databind-%{namedversion}-javadoc.jar %{buildroot}%{_javadir}/jackson-databind-%{namedversion}-javadoc.jar
%{__cp} -p maven2-brew/com/fasterxml/jackson/core/jackson-databind/%{namedversion}/jackson-databind-%{namedversion}-sources.jar %{buildroot}%{_javadir}/jackson-databind-%{namedversion}-sources.jar
(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} -e "s|-%{namedversion}||g"`; done)

# poms
%{__mkdir_p} %{buildroot}%{_mavenpomdir}
%{__cp} -p maven2-brew/com/fasterxml/jackson/core/jackson-databind/%{namedversion}/jackson-databind-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-jackson-databind.pom

# depmaps
%add_to_maven_depmap com.fasterxml.jackson.core jackson-databind %{namedversion} JPP jackson-databind
[ %{name} = "jackson-databind" ] || %{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} %{buildroot}%{_mavendepmapfragdir}/jackson-databind

# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/jackson-databind-%{namedversion}
%{__cp} -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/jackson-databind-%{namedversion}
%{__ln_s} jackson-databind-%{namedversion} %{buildroot}%{_javadocdir}/jackson-databind

# site
%{__mkdir_p} %{buildroot}%{_docdir}/jackson-databind-%{namedversion}
%{__cp} -pr target/site/* %{buildroot}%{_docdir}/jackson-databind-%{namedversion}
%{__rm} -r %{buildroot}%{_docdir}/jackson-databind-%{namedversion}/apidocs
%{__ln_s} %{_javadocdir}/jackson-databind %{buildroot}%{_docdir}/jackson-databind-%{namedversion}/apidocs
%{__ln_s} jackson-databind-%{namedversion} %{buildroot}%{_docdir}/jackson-databind

%clean
%{__rm} -rf %{buildroot}

%post -n jackson-databind
%update_maven_depmap

%postun -n jackson-databind
%update_maven_depmap

%files -n jackson-databind
%defattr(0644,root,root,0755)
%{_javadir}/jackson-databind-%{namedversion}.jar
%{_javadir}/jackson-databind.jar
%{_javadir}/jackson-databind-%{namedversion}-javadoc.jar
%{_javadir}/jackson-databind-javadoc.jar
%{_javadir}/jackson-databind-%{namedversion}-sources.jar
%{_javadir}/jackson-databind-sources.jar
%{_mavenpomdir}/JPP-jackson-databind.pom
%{_mavendepmapfragdir}/jackson-databind

%files -n jackson-databind-javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/jackson-databind-%{namedversion}
%{_javadocdir}/jackson-databind

%files -n jackson-databind-site
%defattr(0644,root,root,0755)
%{_docdir}/jackson-databind-%{namedversion}
%{_docdir}/jackson-databind

%changelog
* Tue Dec 17 2013 David Walluck <dwalluck@redhat.com> 0:2.3.0-2
- loosen version for jackson Requires

* Mon Dec 16 2013 David Walluck <dwalluck@redhat.com> 0:2.3.0-1
- 2.3.0

* Fri Aug 23 2013 David Walluck <dwalluck@redhat.com> 0:2.2.3-1
- 2.2.3

* Wed Aug 07 2013 David Walluck <dwalluck@redhat.com> 0:2.2.2-1
- release
